meta:
  id: spino_header
  endian: le

seq:
  - id: ax25_frame
    type: ax25_frame
    doc-ref: 'https://www.tapr.org/pub_ax25.html'
  - id: payload
    size-eos: true    

types:
  ax25_frame:
    seq:
    - id: ax25_header
      type: ax25_header



  ax25_header:
    seq:
      - id: dest_callsign_raw
        type: dest_callsign_raw
      - id: dest_ssid_raw
        type: u1
      - id: src_callsign_raw
        type: src_callsign_raw
      - id: src_ssid_raw
        type: u1
      - id: ctl
        type: u1
      - id: pid
        type: u1
    instances:
      src_ssid:
        value: (src_ssid_raw & 0x0f) >> 1
      dest_ssid:
        value: (dest_ssid_raw & 0x0f) >> 1
  dest_callsign_raw:
    seq:
      - id: dest_callsign_ror
        process: ror(1)
        size: 6
        type: dest_callsign
  src_callsign_raw:
    seq:
      - id: src_callsign_ror
        process: ror(1)
        type: src_callsign
        size: 6
  dest_callsign:
    seq:
      - id: dest_callsign
        type: str
        encoding: ASCII
        size: 6
  src_callsign:
    seq:
      - id: src_callsign
        type: str
        encoding: ASCII
        size: 6
  digi:
   seq:
      - id: size
        type: u2
      - id: data
        encoding: ASCII
        type: str
        size-eos: true
 

        
        
  payload:
    seq:
      - id: size_frame
        type: u2
      - id: cmd_id
        type: u2
      - id: response_type
        type: u1
      - id: error_code
        type: u1
      - id: spare
        type: u2
      - id: timestamps
        type: u8
      - id: responsetype
        type: str
        encoding: UTF-8
        size: size_frame


